//=============================================================================
// MPU ý 
//
// by nexp76(nexp76@naver.com)
// [system.h]
//=============================================================================

/*

*/

#ifndef	_CONFIG_H_
#define	_CONFIG_H_
//UART0 ϱ 
#define _UART0_ENABLE

//-----------------------------------------------------------------------------
//  
typedef unsigned char UINT;
typedef char INT;
typedef unsigned char BOOL;

typedef unsigned char  u08;	// 0 ~ 255
typedef   signed char  s08;	// -128 ~ 127
typedef unsigned short u16;	// 0 ~ 65535
typedef   signed short s16;	// -32768 ~ 32767
typedef unsigned long  u32;	// 0 ~ (2^32-1)
typedef   signed long  s32;	// -(2^32)/2 ~ ((2^32)/2)-1
//-----------------------------------------------------------------------------




//-----------------------------------------------------------------------------
#ifdef _UART0_ENABLE
#define U0_printf						printf
#define DebugPrint						U0_printf
#define DebugInit						U0_Init
#define DebugGetByte					U0_GetByte
#define DebugIsByte						U0_IsGetByte
#endif

#ifdef _UART1_ENABLE
#define DebugPrint						U1_printf
#define DebugInit						U1_Init
#define DebugGetByte					U1_GetByte
#define DebugIsByte						U1_IsGetByte
#endif
//-----------------------------------------------------------------------------


//-----------------------------------------------------------------------------
//LED Driver
#define LED1_BIT			BIT4
#define LED1_PORT			PORTD
#define Led1Init()			Sbi(DDRD, LED1_BIT)
#define Led1On()			Cbi(LED1_PORT, LED1_BIT)
#define Led1Off()			Sbi(LED1_PORT, LED1_BIT)
#define Led1Toggle()		Tbi(LED1_PORT, LED1_BIT)

#define LED2_BIT			BIT5
#define LED2_PORT			PORTD
#define Led2Init()			Sbi(DDRD, LED2_BIT)
#define Led2On()			Cbi(LED2_PORT, LED2_BIT)
#define Led2Off()			Sbi(LED2_PORT, LED2_BIT)
#define Led2Toggle()		Tbi(LED2_PORT, LED2_BIT)

//-----------------------------------------------------------------------------
//Switch Driver
#define SW1_BIT				BIT6
#define SW1_PORT			PORTD
#define Sw1Init()			Cbi(DDRD, SW1_BIT)
#define GetSw1()			!(PIND&SW1_BIT)
#define WaitForSw1()		while(GetSw1())

#define SW2_BIT				BIT2
#define SW2_PORT			PORTD
#define Sw2Init()			Cbi(DDRD, SW2_BIT)
#define GetSw2()			!(PIND&SW2_BIT)
#define WaitForSw2()		while(GetSw1())



//-----------------------------------------------------------------------------
#define SPI0_SS_BIT						BIT0
#define SPI0_SS_DDR						DDRB
#define SPI0_SS_PORT					PORTB

#define SPI0_SCLK_BIT					BIT1
#define SPI0_SCLK_DDR					DDRB
#define SPI0_SCLK_PORT					PORTB

#define	SPI0_MOSI_BIT					BIT2
#define SPI0_MOSI_DDR					DDRB
#define SPI0_MOSI_PORT					PORTB

#define	SPI0_MISO_BIT					BIT3
#define SPI0_MISO_DDR					DDRB
#define SPI0_MISO_PORT					PORTB

#define MMC_CS_DDR						DDRE
#define MMC_CS_PORT						PORTE
#define MMC_CS_BIT						BIT5

#define SpiInit()						SPI0_Init()
#define SpiSpeed						SPI0_SetSpeed
#define SpiSendData						SPI0_PutByte
#define SpiReadData						SPI0_WriteReadByte

//-----------------------------------------------------------------------------


#include "hal_mega.h"
//#include "board.h"
#endif

