//#include "shift.h"


//LCD
#define LCD_RS_PORT						PORTD
#define LCD_RS_DDR						DDRD
#define LCD_RS_BIT						BIT3

#define LCD_CS_PORT						PORTB
#define LCD_CS_DDR						DDRB
#define LCD_CS_BIT						BIT5

#define LCD_DATA_MASK					BIT1|BIT2|BIT3|BIT4
#define LCD_DATA_PORT					PORTB
#define LCD_DATA_DDR					DDRB


#define LCD_RW_INIT()
#define LCD_RWON()
#define LCD_RWOFF()

#define LCD_RS_INIT()					Sbi(LCD_RS_DDR, LCD_RS_BIT)
#define LCD_RSON()						Sbi(LCD_RS_PORT, LCD_RS_BIT)	
#define LCD_RSOFF()						Cbi(LCD_RS_PORT, LCD_RS_BIT)

#define LCD_EN_INIT()					Sbi(LCD_CS_DDR, LCD_CS_BIT)
#define LCD_ENABLE()					Sbi(LCD_CS_PORT, LCD_CS_BIT)
#define LCD_DISABLE()					Cbi(LCD_CS_PORT, LCD_CS_BIT)

#define LCD_DATA(Data)					LCD_DATA_PORT = (LCD_DATA_PORT&(~LCD_DATA_MASK)) | ((Data>>3)&LCD_DATA_MASK); LCD_ENABLE();LCD_DISABLE();LCD_DATA_PORT = (LCD_DATA_PORT&(~LCD_DATA_MASK)) | ((Data<<1)&LCD_DATA_MASK)

void lcd_hal_init(void);

void lcd_hal_init(void)
{
	LCD_RW_INIT();
	LCD_RS_INIT();
	LCD_EN_INIT();
	LCD_DATA_DDR |= LCD_DATA_MASK;	
	
	LCD_DISABLE();
	LCD_RSOFF();	
	LCD_RWOFF();
}

void lcd_delay(unsigned int time)
{
    unsigned int i, j;
    while(time)
    {
	    for(i=0;i<3;i++)
	    	for(j=0;j<10;j++);
	        	time--;
    }
}


void lcd_command(unsigned char Value)
{
	lcd_delay(LCD_DELAY);	//busy check	
	LCD_RSOFF();	
	LCD_RWOFF();

	LCD_DATA(Value);
	
	LCD_ENABLE();	
	LCD_DISABLE();
}

void lcd_data(unsigned char ch)
{
	lcd_delay(LCD_DELAY);	//busy check		
	LCD_RSON();							//RS On
	LCD_RWOFF();	

	LCD_DATA(ch);

	LCD_ENABLE();	
	LCD_DISABLE();
}

